//*** LICENSE ***
//ColumnListView, its associated classes and source code, and the other components of Santa's Gift Bag are
//being made publicly available and free to use in freeware and shareware products with a price under $25
//(I believe that shareware should be cheap). For overpriced shareware (hehehe) or commercial products,
//please contact me to negotiate a fee for use. After all, I did work hard on this class and invested a lot
//of time into it. That being said, DON'T WORRY I don't want much. It totally depends on the sort of project
//you're working on and how much you expect to make off it. If someone makes money off my work, I'd like to
//get at least a little something.  If any of the components of Santa's Gift Bag are is used in a shareware
//or commercial product, I get a free copy.  The source is made available so that you can improve and extend
//it as you need. In general it is best to customize your ColumnListView through inheritance, so that you
//can take advantage of enhancements and bug fixes as they become available. Feel free to distribute the 
//ColumnListView source, including modified versions, but keep this documentation and license with it.

//*** DESCRIPTION ***
//Enhanced BApplication.  Provides facilities for registering windows and background
//threads and quits the application after the last window or thread is unregistered.

#include "DocumentApp.h"


DocumentApp::DocumentApp(const char* a_signature)
: BApplication(a_signature)
{
	m_window_and_process_holds = 0;
	m_quit_process = false;
}


DocumentApp::~DocumentApp()
{ }


bool DocumentApp::QuitRequested()
{
	m_quit_process = true;
	return BApplication::QuitRequested();
}


void DocumentApp::CancelQuitProcess()
{
	m_quit_process = false;
}


bool DocumentApp::IsQuitInProgress()
{
	return m_quit_process;
}


void DocumentApp::RegisterWindow()
{
	m_quit_process = false;
	ProcessHold();
}


void DocumentApp::UnregisterWindow()
{
	ProcessDone();
}


void DocumentApp::ProcessHold()
{
	atomic_add(&m_window_and_process_holds,1);
}


void DocumentApp::ProcessDone()
{
	if(atomic_add(&m_window_and_process_holds,-1) == 1)
		//This is the last hold, so user is done
		be_app->PostMessage(B_QUIT_REQUESTED);
}


int32 DocumentApp::CountRegWindProcHolds()
{
	return m_window_and_process_holds;
}
