//Name:		FSCheckBox.cpp
//Author:	Brian Tietz
//Copyright 1999
//Conventions:
//	Global constants (declared with const) and #defines - begin with "c_" followed by lowercase
//		words separated by underscores.
//		(E.G., #define c_my_constant 5).
//		(E.G., const int c_my_constant = 5;).
//	Global variables - begin with "g_" followed by lowercase words separated by underscores.
//		(E.G., int g_my_global;).
//	New data types (classes, structs, typedefs, etc.) - begin with an uppercase letter followed by
//		lowercase words separated by uppercase letters.  Enumerated constants contain a prefix
//		associating them with a particular enumerated set.
//		(E.G., typedef int MyTypedef;).
//		(E.G., enum MyEnumConst {c_mec_one, c_mec_two};)
//	Private member variables - begin with "m_" followed by lowercase words separated by underscores.
//		(E.G., int m_my_member;).
//	Public or friend-accessible member variables - all lowercase words separated by underscores.
//		(E.G., int public_member;).
//	Argument and local variables - begin with a lowercase letter followed by
//		lowercase words separated by underscores.  If the name is already taken by a public member
//		variable, prefix with a_ or l_
//		(E.G., int my_local; int a_my_arg, int l_my_local).
//	Functions (member or global) - begin with an uppercase letter followed by lowercase words
//		separated by uppercase letters.
//		(E.G., void MyFunction(void);).


//******************************************************************************************************
//**** Project header files
//******************************************************************************************************
#include "FSCheckBox.h"


//******************************************************************************************************
//**** FSCheckBox
//******************************************************************************************************
FSCheckBox::FSCheckBox(const char* name, const char* label, BMessage* message, uint32 resizeMask,
	uint32 flags)
: BCheckBox(BRect(0,0,100,10),name,label,message,resizeMask,flags)
{
	ResizeToPreferred();
}


void FSCheckBox::SetFont(const BFont* font, uint32 mask)
{
	BCheckBox::SetFont(font,mask);
	ResizeToPreferred();
}


void FSCheckBox::SetVisualWidth(float width)
{
	ResizeTo(width+5,Frame().Height());
}


void FSCheckBox::SetVisualHeight(float height)
{
	BRect frame = Frame();
	BRect visual_frame = VisualFrame();
	ResizeTo(frame.Width(),height+(frame.Height()-visual_frame.Height()));
}


void FSCheckBox::SetVisualSize(float width, float height)
{
	BRect frame = Frame();
	BRect visual_frame = VisualFrame();
	ResizeTo(width+5,height+(frame.Height()-visual_frame.Height()));
}


float FSCheckBox::VisualLeft()
{
	return Frame().left+1;
}


float FSCheckBox::VisualRight()
{
	return Frame().right-4;
}


float FSCheckBox::VisualTop()
{
	return Frame().top+3;
}


float FSCheckBox::VisualBottom()
{
	//Thanks go out to Pavel Cisler for providing the information necessary to make this calculation
	BFont font;
	GetFont(&font);
	struct font_height font_height_struct;
	font.GetHeight(&font_height_struct);
	return Frame().bottom - (ceil(font_height_struct.ascent + font_height_struct.descent) -
		rint(font_height_struct.ascent) + 1);
}


void FSCheckBox::MoveToVisualPosition(BPoint visual_position)
{
	MoveTo(visual_position.x-1,visual_position.y-3);
}

