//Name:		FSLeftLabelView.h
//Author:	Brian Tietz
//Copyright 1999
//Conventions:
//	Global constants (declared with const) and #defines - begin with "c_" followed by lowercase
//		words separated by underscores.
//		(E.G., #define c_my_constant 5).
//		(E.G., const int c_my_constant = 5;).
//	Global variables - begin with "g_" followed by lowercase words separated by underscores.
//		(E.G., int g_my_global;).
//	New data types (classes, structs, typedefs, etc.) - begin with an uppercase letter followed by
//		lowercase words separated by uppercase letters.  Enumerated constants contain a prefix
//		associating them with a particular enumerated set.
//		(E.G., typedef int MyTypedef;).
//		(E.G., enum MyEnumConst {c_mec_one, c_mec_two};)
//	Private member variables - begin with "m_" followed by lowercase words separated by underscores.
//		(E.G., int m_my_member;).
//	Public or friend-accessible member variables - all lowercase words separated by underscores.
//		(E.G., int public_member;).
//	Argument and local variables - begin with a lowercase letter followed by
//		lowercase words separated by underscores.  If the name is already taken by a public member
//		variable, prefix with a_ or l_
//		(E.G., int my_local; int a_my_arg, int l_my_local).
//	Functions (member or global) - begin with an uppercase letter followed by lowercase words
//		separated by uppercase letters.
//		(E.G., void MyFunction(void);).


#ifndef _FONT_SENSITIVE_LEFT_LABEL_VIEW_H_
#define _FONT_SENSITIVE_LEFT_LABEL_VIEW_H_


//******************************************************************************************************
//**** Project header files
//******************************************************************************************************
#include "FSView.h"


//******************************************************************************************************
//**** FSLeftLabelView
//******************************************************************************************************
class FSLeftLabelView : public FSView
{
	public:
		//For derived classes to implement
		virtual float VisualDivider() = 0;				//Note: Position is relative to visual left
		virtual void SetVisualDivider(float divider) = 0;

		//Alignment function
		static void Align(FSLeftLabelView** labelled_views, int32 num_views, bool align_left = true,
			bool align_divider = true, bool align_right = true, bool space_vertically = true,
			float v_spacing = 5);
			//The position of labelled_views[0] is used as the starting point
};


#endif //_FONT_SENSITIVE_LEFT_LABEL_VIEW_H_
